<?php

namespace App\DataTables;

use App\Models\RigaFatturazione;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class RigaFatturazioneDataTableEditor extends DataTablesEditor
{
  protected $model = RigaFatturazione::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'attivita_id.required' => 'L\'attività è richiesta',
    'qta.required' => 'La quantità è richiesta',
    'prezzo.required' => 'Il prezzo è richiesto',
    'tipo.required' => 'Il tipo è richiesto',
    'listino_prezzi_id.required' => 'Il listino prezzi è richiesto',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'attivita_id'  => 'required',
      'qta' => 'required',
      // 'prezzo' => 'required',
      // 'tipo' => 'required',
      'listino_prezzi_id' => 'required',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'attivita_id'  => 'required',
      'qta' => 'required',
      // 'prezzo' => 'required',
      // 'tipo' => 'required',
      'listino_prezzi_id' => 'required',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
   $listinoPrezzi = \App\Models\ListinoPrezzi::find($data['listino_prezzi_id']);
    $data['prezzo'] = $listinoPrezzi->prezzo;
    $data['tipo'] = $listinoPrezzi->categoria;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
